diff -urN sourceold/scripts/engine_script.cpp source/scripts/engine_script.cpp
--- sourceold/scripts/engine_script.cpp	2018-11-17 10:23:57.173600000 +1000
+++ source/scripts/engine_script.cpp	2020-09-10 09:08:27.958838700 +1000
@@ -11,6 +11,7 @@
 */
 #include "general.h"
 #include "scripts.h"
+#include "engine_script.h"
 #include "engine_vector.h"
 #include "ScriptableGameObj.h"
 #include "slist.h"
@@ -418,7 +419,7 @@
 
 SCRIPTS_API GameObject *Find_Closest_Object_With_Script(const char *script, Vector3 pos)
 {
-	float closestdist = 0.0f;
+	float closestdist = FLT_MAX;
 	GameObject *closest = NULL;
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
@@ -433,8 +434,8 @@
 		{
 			if (Is_Script_Attached(o2, script))
 			{
-				float dist = Commands->Get_Distance(Commands->Get_Position(o2),pos);
-				if (closest == NULL || dist < closestdist)
+				float dist = Vector3::Distance_Squared(Commands->Get_Position(o2), pos);
+				if (dist < closestdist)
 				{
 					closestdist = dist;
 					closest = o2;
@@ -514,6 +515,50 @@
     delete d->Data();
 }
 
+SCRIPTS_API void Find_All_Vehicles_By_Distance(SList<GameObject>& objects, Vector3 position)
+{
+  objects.Remove_All();
+
+  // Internal list of distances, in the same order as GameObjects in objects
+  SList<float> distances;
+
+  for ( SLNode<BaseGameObj>* objNode = GameObjManager::GameObjList.Head(); objNode != NULL; objNode = objNode->Next() )
+  {
+    ScriptableGameObj* obj = (objNode->Data()) ? objNode->Data()->As_ScriptableGameObj() : NULL;
+	if ( obj && obj->As_VehicleGameObj() )
+    {
+      // SList cannot contain non-pointer types... stupid thing!
+      float* distance = new float;
+      *distance = Commands->Get_Distance(Commands->Get_Position(obj), position);
+
+      SLNode<float>* d = distances.Head();
+      for ( SLNode<GameObject>* o = objects.Head();
+        d != NULL;
+        d = d->Next(), o = o->Next() )
+      {
+        if ( *distance < *d->Data() )
+        {
+          objects.insertBefore(obj, *o);
+          distances.insertBefore(distance, *d);
+          distance = NULL;
+          break;
+        }
+      }
+
+      // OK, all existing objects are closer than this one so add it to the end of the list
+      if ( distance != NULL )
+      {
+        objects.Add_Tail(obj);
+        distances.Add_Tail(distance);
+      }
+    }
+  }
+
+  // Clean up memory since SList insists on having heap objects...
+  for ( SLNode<float>* d = distances.Head(); d != NULL; d = d->Next() )
+    delete d->Data();
+}
+
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script( GameObject *sender, const char *script, int message, int param, float delay )
 {
 	if (!sender)
@@ -560,7 +605,7 @@
 		{
 			if ( Is_Script_Attached( o2, script )
 				&& Commands->Get_ID ( sender ) != Commands->Get_ID ( o2 )
-				&& Commands->Get_Distance ( Commands->Get_Position ( sender ), Commands->Get_Position ( o2 ) ) <= range )
+				&& Vector3::Distance_Squared ( Commands->Get_Position ( sender ), Commands->Get_Position ( o2 ) ) <= range * range )
 			{
 				Commands->Send_Custom_Event(sender,o2,message,param,delay);
 			}
@@ -627,4 +672,48 @@
   va_start ( vargs, params );
   Attach_Script_V(pObj,script,params,vargs);
   va_end(vargs);
-}
\ No newline at end of file
+}
+
+int Get_Param_Type(const char *str)
+{
+	for (int i = 0; i < PARAM_TYPE_COUNT; i++)
+	{
+		if (!lstrcmpiA(str, PARAM_TYPE_STRINGS[i]))
+		{
+			return i;
+		}
+	}
+	return 0;
+}
+
+SCRIPTS_API void Get_Script_Parameters(const char *script, DynamicVectorClass<ScriptParameter> &parameters)
+{
+	parameters.Delete_All();
+	auto factory = ScriptRegistrar::GetScriptFactory(script);
+	if (!factory)
+	{
+		return;
+	}
+	char* working = newstr(factory->GetParamDescription());
+	char *param = strtok(working, ",");
+	while (param)
+	{
+		char *sname = param;
+		char *type = strchr(param, ':');
+		type[0] = '\0';
+		type++;
+		char *value = strrchr(param, '=');
+		if (value)
+		{
+			value[0] = '\0';
+			value++;
+		}
+		ScriptParameter p;
+		p.name = sname;
+		p.value = value;
+		p.type = Get_Param_Type(type);
+		parameters.Add(p);
+		param = strtok(nullptr, ",");
+	}
+	delete[] working;
+}
diff -urN sourceold/scripts/engine_script.h source/scripts/engine_script.h
--- sourceold/scripts/engine_script.h	2018-11-17 10:23:57.173600000 +1000
+++ source/scripts/engine_script.h	2020-03-28 21:10:59.024829200 +1000
@@ -12,6 +12,7 @@
 #ifndef SCRIPTS_INCLUDE__ENGINE_SCRIPT_H
 #define SCRIPTS_INCLUDE__ENGINE_SCRIPT_H
 #include "scripts.h"
+#include "engine_string.h"
 #include "SList.h"
 
 SCRIPTS_API void Remove_Script(GameObject *obj,const char *script); //removes all copies of <script> from an object
@@ -52,6 +53,7 @@
 *   The position to calculate distance from
 */
 SCRIPTS_API void Find_All_Objects_With_Script_By_Distance(const char *script, SList<GameObject>& objects, Vector3 position);
+SCRIPTS_API void Find_All_Vehicles_By_Distance(SList<GameObject>& objects, Vector3 position);
 
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script( GameObject *sender, const char *script, int message, int param, float delay ); // Script to send a custom to all objects with a specific script
 SCRIPTS_API void Send_Custom_Event_To_Objects_With_Script_Ranged( GameObject *sender, const char *script, int message, int param, float delay, float range ); // Script to send a custom to all objects with a specific script in a specified range
@@ -113,5 +115,55 @@
 */
 SCRIPTS_API void Attach_Script_Once_V ( GameObject* pObj, const char* script, const char* params, ... );
 
+class ScriptParameter : public NoEqualsClass<ScriptParameter>
+{
+public:
+	StringClass name;
+	StringClass value;
+	int type;
+};
+
+typedef enum
+{
+	PARAM_TYPE_INT = 0,
+	PARAM_TYPE_FLOAT,
+	PARAM_TYPE_STRING,
+	PARAM_TYPE_BOOL,
+	PARAM_TYPE_ID,
+	PARAM_TYPE_VECTOR3,
+	PARAM_TYPE_ENUM,
+	PARAM_TYPE_EMITTER,
+	PARAM_TYPE_WEAPON,
+	PARAM_TYPE_AMMO,
+	PARAM_TYPE_EXPLOSION,
+	PARAM_TYPE_ANIMATION,
+	PARAM_TYPE_GANG,
+	PARAM_TYPE_FILE,
+	PARAM_TYPE_SOUND,
+	PARAM_TYPE_COLOR,
+	PARAM_TYPE_COUNT
+} PARAM_TYPES;
+
+const char * const PARAM_TYPE_STRINGS[PARAM_TYPE_COUNT] =
+{
+	"int",
+	"float",
+	"string",
+	"bool",
+	"ID",
+	"vector3",
+	"enum",
+	"emitter",
+	"weapon",
+	"ammo",
+	"explosion",
+	"animation",
+	"gang",
+	"file",
+	"sound",
+	"color",
+};
+
+SCRIPTS_API void Get_Script_Parameters(const char *script, DynamicVectorClass<ScriptParameter> &parameters);
 
 #endif
diff -urN sourceold/scripts/engine_string.h source/scripts/engine_string.h
--- sourceold/scripts/engine_string.h	2018-11-17 10:23:57.175600000 +1000
+++ source/scripts/engine_string.h	2020-09-10 09:08:27.958838700 +1000
@@ -1106,6 +1106,45 @@
     }
 };
 
+struct hash_string
+{
+	size_t operator()(const char* str) const
+	{
+		// djb2
+		unsigned long hash = 5381;
+		while (int c = *str++) hash = hash * 33 + c;
+		return hash;
+	}
+
+	size_t operator()(const StringClass& str) const
+	{
+		return (*this)(str.Peek_Buffer());
+	}
+};
+
+struct equals_string
+{
+	bool operator()(const char* a, const char* b) const
+	{
+		return strcmp(a, b) == 0;
+	}
+
+	size_t operator()(const StringClass& a, const StringClass& b) const
+	{
+		return strcmp(a.Peek_Buffer(), b.Peek_Buffer()) == 0;
+	}
+
+	size_t operator()(const StringClass& a, const char* b) const
+	{
+		return strcmp(a.Peek_Buffer(), b) == 0;
+	}
+
+	size_t operator()(const char* a, const StringClass& b) const
+	{
+		return strcmp(a, b.Peek_Buffer()) == 0;
+	}
+};
+
 SCRIPTS_API const wchar_t *CharToWideChar(const char *str); //convert a char to a wide char
 SCRIPTS_API const char *WideCharToChar(const wchar_t *wcs); //convert a wide char to a char
 SCRIPTS_API char *newstr(const char *str); //duplicate a character string
diff -urN sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2019-06-22 07:43:44.226400000 +1000
+++ source/scripts/engine_tt.cpp	2020-09-26 08:59:57.388154600 +1000
@@ -186,6 +186,9 @@
 SCRIPTS_API rwpa Retrieve_Waypaths;
 SCRIPTS_API rwpo Retrieve_Waypoints;
 SCRIPTS_API gwp Get_Waypoint_Position;
+SCRIPTS_API trc Test_Raycast_Collision;
+SCRIPTS_API iib Is_Inside_AABox;
+SCRIPTS_API cgst Can_Generic_Soldier_Teleport;
 SCRIPTS_API cl Create_Lightning;
 SCRIPTS_API gc Get_Clouds;
 SCRIPTS_API gli Get_Lightning;
@@ -228,6 +231,39 @@
 SCRIPTS_API gpda Get_Pathfind_Distance_Async;
 SCRIPTS_API cgpd Cancel_Get_Pathfind_Distance;
 SCRIPTS_API gpdb Get_Pathfind_Distance_Blocking;
+SCRIPTS_API gmsl Get_Multiplayer_Spawn_Location;
+SCRIPTS_API esbn Enable_Spawners_By_Name;
+SCRIPTS_API ipg Is_Pathfind_Generated;
+SCRIPTS_API gcps Get_Closest_Pathfind_Spot;
+SCRIPTS_API gcpss Get_Closest_Pathfind_Spot_Size;
+SCRIPTS_API grcs Get_Radio_Command_String;
+SCRIPTS_API sei Set_Emot_Icon;
+SCRIPTS_API kmd Kill_Messages_Disabled;
+SCRIPTS_API ise Is_Sidebar_Enabled;
+SCRIPTS_API iee Is_Extras_Enabled;
+SCRIPTS_API cbg Can_Build_Ground;
+SCRIPTS_API cba Can_Build_Air;
+SCRIPTS_API cbn Can_Build_Naval;
+SCRIPTS_API isb Is_Soldier_Busy;
+SCRIPTS_API ioep Is_On_Enemy_Pedestal;
+SCRIPTS_API fcpp Find_Closest_Poly_Position;
+SCRIPTS_API sdd Say_Dynamic_Dialogue;
+SCRIPTS_API sddp Say_Dynamic_Dialogue_Player;
+SCRIPTS_API sddt Say_Dynamic_Dialogue_Team;
+SCRIPTS_API elp Enable_Letterbox_Player;
+SCRIPTS_API cst Create_Sound_Team;
+SCRIPTS_API c2dst Create_2D_Sound_Team;
+SCRIPTS_API c2dwst Create_2D_WAV_Sound_Team;
+SCRIPTS_API c2dwstd Create_2D_WAV_Sound_Team_Dialog;
+SCRIPTS_API c2dwstc Create_2D_WAV_Sound_Team_Cinematic;
+SCRIPTS_API c3dwsbt Create_3D_WAV_Sound_At_Bone_Team;
+SCRIPTS_API c3dsbt Create_3D_Sound_At_Bone_Team;
+SCRIPTS_API _Stop_Sound_Player Stop_Sound_Player;
+SCRIPTS_API _Stop_Sound_Team Stop_Sound_Team;
+SCRIPTS_API ssa Set_Subobject_Animation;
+SCRIPTS_API sts Set_Time_Scale;
+SCRIPTS_API ssap Set_Subobject_Animation_Player;
+SCRIPTS_API wfa Write_File_Async;
 
 SCRIPTS_API bool Can_Team_Build_Vehicle(int Team)
 {
@@ -243,6 +279,144 @@
 	return true;
 }
 
+SCRIPTS_API DynamicVectorClass<int> Get_Enlisted_Purchase_Items(int team)
+{
+	DynamicVectorClass<int> list;
+	TeamPurchaseSettingsDefClass *t = TeamPurchaseSettingsDefClass::Get_Definition((TeamPurchaseSettingsDefClass::TEAM)PTTEAM(team));
+	for (int i = 0; i < 4; i++)
+	{
+		if (t->Get_Enlisted_Definition(i) != 0)
+			list.Add(t->Get_Enlisted_Definition(i));
+	}
+	return list;
+}
+
+SCRIPTS_API DynamicVectorClass<int> Get_Purchase_Items(int team, int defType)
+{
+	DynamicVectorClass<int> list;
+	PurchaseSettingsDefClass *purchaseSettings = PurchaseSettingsDefClass::Find_Definition((PurchaseSettingsDefClass::TYPE)defType, (PurchaseSettingsDefClass::TEAM)PTTEAM(team));
+	if (purchaseSettings)
+	{
+		for (int i = 0; i < 10; i++)
+		{
+			if (purchaseSettings->Get_Definition(i) != 0)
+				list.Add(purchaseSettings->Get_Definition(i));
+		}
+	}
+	return list;
+}
+
+SCRIPTS_API bool Is_Preset_Purchasable_In_List(int id, int team, PurchaseSettingsDefClass::TYPE def)
+{
+	PurchaseSettingsDefClass *purchaseSettings = PurchaseSettingsDefClass::Find_Definition(def, (PurchaseSettingsDefClass::TEAM)PTTEAM(team));
+	if (purchaseSettings && !purchaseSettings->Get_Page_Hidden() && !purchaseSettings->Get_Page_Busy() && !purchaseSettings->Get_Page_Disabled())
+	{
+		for (int i = 0; i < 10; i++)
+		{
+			if ((purchaseSettings->Get_Definition(i) == id) ||
+				(purchaseSettings->Get_Alt_Definition(i, 0) == id) || (purchaseSettings->Get_Alt_Definition(i, 1) == id) || (purchaseSettings->Get_Alt_Definition(i, 2) == id))
+			{
+				// No unit limit in 4.x?
+				/*if (int unitlimit = purchaseSettings->Get_Unit_Limit(i))
+				{
+					int count = Count_Objects_Of_Preset(2, purchaseSettings->Get_Definition(i));
+					count += Count_Objects_Of_Preset(2, purchaseSettings->Get_Alt_Definition(i, 0));
+					count += Count_Objects_Of_Preset(2, purchaseSettings->Get_Alt_Definition(i, 1));
+					count += Count_Objects_Of_Preset(2, purchaseSettings->Get_Alt_Definition(i, 2));
+					if (unitlimit <= count)
+					{
+						return false;
+					}
+				}*/
+				return !purchaseSettings->Get_Disabled(i) && !purchaseSettings->Get_Busy(i) && !purchaseSettings->Get_Hidden(i);
+			}
+		}
+	}
+	return false;
+}
+
+SCRIPTS_API bool Is_Infantry_Purchaseable(const char *preset,int team)
+{
+	int id = Get_Definition_ID(preset);
+	if (!id)
+	{
+		return false;
+	}
+
+	TeamPurchaseSettingsDefClass *t = TeamPurchaseSettingsDefClass::Get_Definition((TeamPurchaseSettingsDefClass::TEAM)PTTEAM(team));
+	
+	for (int i = 0; i < 4; i++)
+	{
+		if (t->Get_Enlisted_Definition(i) == id)
+		{
+			// No unit limit in 4.x?
+			/*int unitlimit = t->Get_Unit_Limit(i);
+			if (unitlimit)
+			{
+				if (unitlimit <= Count_Objects_Of_Preset(2, t->Get_Enlisted_Definition(i)))
+				{
+					return false;
+				}
+			}*/
+			return !t->Get_Disabled(i) && !t->Get_Busy(i) && !t->Get_Hidden(i);
+		}
+	}
+
+	BaseControllerClass *baseController = BaseControllerClass::Find_Base(team); // This does not require a PurchaseSettingsDefClass team
+
+	if (!baseController || baseController->Can_Generate_Soldiers())
+	{
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_CLASSES))
+			return true;
+
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_SECRET_CLASSES))
+			return true;
+	}
+
+	return false;
+}
+
+SCRIPTS_API bool Is_Vehicle_Purchaseable(const char *preset,int team)
+{
+	int id = Get_Definition_ID(preset);
+	if (!id)
+	{
+		return false;
+	}
+
+	BaseControllerClass *baseController = BaseControllerClass::Find_Base(team); // This does not require a PurchaseSettingsDefClass team
+	
+	if (!baseController || (baseController->Can_Generate_Vehicles() && Can_Build_Ground(team)))
+	{
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_VEHICLES) && !(Get_Vehicle_Definition_Mode(preset) == VEHICLE_TYPE_FLYING && !Is_Map_Flying()))
+			return true;
+
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES))
+			return true;
+	}
+
+	if (!baseController || Can_Build_Air(team))
+	{
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_AIR))
+			return true;
+
+		// Air vehicles can be present on the ground vehicle lists!
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_VEHICLES) && !(Get_Vehicle_Definition_Mode(preset) == VEHICLE_TYPE_FLYING && !Is_Map_Flying()))
+			return true;
+
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_SECRET_VEHICLES))
+			return true;
+	}
+
+	if (!baseController || Can_Build_Naval(team))
+	{
+		if (Is_Preset_Purchasable_In_List(id, team, PurchaseSettingsDefClass::TYPE_NAVAL))
+			return true;
+	}
+
+	return false;
+}
+
 SCRIPTS_API void Send_Message_With_Team_Color(int Team,const char *Msg)
 {
 	unsigned int Red = 0,Blue = 0,Green = 0;
@@ -342,137 +516,6 @@
 			}
 		}
 		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_Sound_Team(const char *soundname,const Vector3 & position,GameObject *obj,int team)
-{
-	if (!obj)
-	{
-		return;
-	}
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_Sound_Player(o,soundname,position,obj);
-			}
-		}
-		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_2D_Sound_Team(const char *soundname,int team)
-{
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_2D_Sound_Player(o,soundname);
-			}
-		}
-		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_2D_WAV_Sound_Team(const char *soundname,int team)
-{
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_2D_WAV_Sound_Player(o,soundname);
-			}
-		}
-		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_2D_WAV_Sound_Team_Dialog(const char *soundname,int team)
-{
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_2D_Wave_Sound_Dialog_Player(o,soundname);
-			}
-		}
-		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_2D_WAV_Sound_Team_Cinematic(const char *soundname,int team)
-{
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_2D_Wave_Sound_Cinematic_Player(o,soundname);
-			}
-		}
-		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_3D_WAV_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team)
-{
-	if (!obj)
-	{
-		return;
-	}
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_3D_WAV_Sound_At_Bone_Player(o,soundname,obj,bonename);
-			}
-		}
-		x = x->Next();
-	}
-}
-
-SCRIPTS_API void Create_3D_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team)
-{
-	if (!obj)
-	{
-		return;
-	}
-	SLNode<SoldierGameObj> *x = GameObjManager::StarGameObjList.Head();
-	while (x)
-	{
-		GameObject *o = x->Data();
-		if (o)
-		{
-			if ((Get_Object_Type(o) == team) || (team == 2))
-			{
-				Create_3D_Sound_At_Bone_Player(o,soundname,obj,bonename);
-			}
-		}
-		x = x->Next();
 	}
 }
 
diff -urN sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2019-06-22 07:43:44.227400000 +1000
+++ source/scripts/engine_tt.h	2020-09-26 08:59:57.389151600 +1000
@@ -148,6 +148,9 @@
 typedef void (*rwpa) (DynamicVectorClass<int> &WaypathIDs);
 typedef void (*rwpo) (int WaypathID, DynamicVectorClass<int> &WaypointIDs);
 typedef void (*gwp) (int WaypathID, int WaypointID, Vector3 &Pos);
+typedef bool (*trc) (const Vector3 &pos1, const Vector3 &pos2, const bool checkDynamicObjects, Vector3 *contactPoint, GameObject *compareObj);
+typedef bool (*iib) (const AABoxClass &box, const Vector3 &pos);
+typedef bool (*cgst) (Vector3 position);
 typedef void (*cl) (const AmmoDefinitionClass *ammodef,Vector3 &start,Vector3 &end);
 typedef void (*gc) (float &cloudcover, float &gloominess);
 typedef void (*gli) (float &intensity, float &startdistance, float &enddistance, float &heading, float &distribution);
@@ -185,6 +188,39 @@
 typedef uint32 (*gpda) (SmartGameObj* pathObj, const Vector3 &dest, PathfindDistanceCallback callback, void *data);
 typedef bool(*gpdb) (SmartGameObj* pathObj, const Vector3& dest, float& distanceResult, PathfindDistanceResult& pathfindResult);
 typedef bool (*cgpd) (uint32 id);
+typedef void (*gmsl) (sint32 team, SoldierGameObj* soldier, Matrix3D &location);
+typedef void (*esbn) (const char *name, bool enable);
+typedef bool (*ipg) ();
+typedef bool (*gcps) (const Vector3 &center, float maxDistance, Vector3 *returnPosition);
+typedef bool (*gcpss) (const Vector3 &center, float maxDistance, Vector3 *returnPosition, float minSectorSize);
+typedef int (*grcs) (int index);
+typedef int (*sei) (SoldierGameObj *obj, int emoticonId);
+typedef bool (*kmd) ();
+typedef bool (*ise) ();
+typedef bool (*iee) ();
+typedef bool (*cbg) (int team);
+typedef bool (*cba) (int team);
+typedef bool (*cbn) (int team);
+typedef bool (*isb) (SoldierGameObj *obj);
+typedef bool (*ioep) (BeaconGameObj *obj);
+typedef void (*fcpp) (BuildingGameObj *building, Vector3 &pos, Vector3 *polyPos);
+typedef void (*sdd) (int text_id, SoldierGameObj* speaker, int* sound_id);
+typedef void (*sddp) (GameObject* player, int text_id, SoldierGameObj* speaker, int* sound_id);
+typedef void (*sddt) (int text_id, SoldierGameObj* speaker, int* sound_id, int team);
+typedef void (*elp) (GameObject* player, bool onoff, float seconds);
+typedef int (*cst) (const char* soundname, const Vector3& position, GameObject* obj2, int team);
+typedef int (*c2dst) (const char* soundname, int team);
+typedef int (*c2dwst) (const char* soundname, int team);
+typedef int (*c2dwstd) (const char* soundname, int team);
+typedef int (*c2dwstc) (const char* soundname, int team);
+typedef int (*c3dwsbt) (const char* soundname, GameObject* obj, const char* bonename, int team);
+typedef int (*c3dsbt) (const char* soundname, GameObject* obj, const char* bonename, int team);
+typedef int (*_Stop_Sound_Player) (GameObject* player, int sound_id, bool destroy_sound);
+typedef int (*_Stop_Sound_Team) (int sound_id, bool destroy_sound, int team);
+typedef int (*ssa) (GameObject *obj,const char *animation,bool looping,const char *subobject,float startFrame,float endFrame,bool blended);
+typedef void (*sts) (float scale);
+typedef int (*ssap) (GameObject *player,GameObject *obj,const char *animation,bool looping,const char *subobject,float startFrame,float endFrame,bool blended);
+typedef int (*wfa) (const char *_FileName, const char *_Text);
 SCRIPTS_API extern gpl Get_Player_List;
 SCRIPTS_API extern gcmi Get_Current_Map_Index;
 SCRIPTS_API extern gm Get_Map;
@@ -329,6 +365,9 @@
 SCRIPTS_API extern rwpa Retrieve_Waypaths;
 SCRIPTS_API extern rwpo Retrieve_Waypoints;
 SCRIPTS_API extern gwp Get_Waypoint_Position;
+SCRIPTS_API extern trc Test_Raycast_Collision;
+SCRIPTS_API extern iib Is_Inside_AABox;
+SCRIPTS_API extern cgst Can_Generic_Soldier_Teleport;
 SCRIPTS_API extern cl Create_Lightning;
 SCRIPTS_API extern gc Get_Clouds;
 SCRIPTS_API extern gli Get_Lightning;
@@ -371,6 +410,39 @@
 SCRIPTS_API extern gpda Get_Pathfind_Distance_Async; // Returns > 0 when succusful. pathObj must be a vehicle or a soldier
 SCRIPTS_API extern cgpd Cancel_Get_Pathfind_Distance; // Cancels a pathfind distance request. Use the result from Get_Pathfind_Distance_Async/Get_Pathfind_Distance to cancel
 SCRIPTS_API extern gpdb Get_Pathfind_Distance_Blocking; // Returns > 0 when succesful. Solves distances immediately. pathObj must be a vehicle or a soldier
+SCRIPTS_API extern gmsl Get_Multiplayer_Spawn_Location;
+SCRIPTS_API extern esbn Enable_Spawners_By_Name;
+SCRIPTS_API extern ipg Is_Pathfind_Generated;
+SCRIPTS_API extern gcps Get_Closest_Pathfind_Spot;
+SCRIPTS_API extern gcpss Get_Closest_Pathfind_Spot_Size;
+SCRIPTS_API extern grcs Get_Radio_Command_String;
+SCRIPTS_API extern sei Set_Emot_Icon;
+SCRIPTS_API extern kmd Kill_Messages_Disabled;
+SCRIPTS_API extern ise Is_Sidebar_Enabled;
+SCRIPTS_API extern iee Is_Extras_Enabled;
+SCRIPTS_API extern cbg Can_Build_Ground;
+SCRIPTS_API extern cba Can_Build_Air;
+SCRIPTS_API extern cbn Can_Build_Naval;
+SCRIPTS_API extern isb Is_Soldier_Busy;
+SCRIPTS_API extern ioep Is_On_Enemy_Pedestal;
+SCRIPTS_API extern fcpp Find_Closest_Poly_Position;
+SCRIPTS_API extern sdd Say_Dynamic_Dialogue;
+SCRIPTS_API extern sddp Say_Dynamic_Dialogue_Player;
+SCRIPTS_API extern sddt Say_Dynamic_Dialogue_Team;
+SCRIPTS_API extern elp Enable_Letterbox_Player;
+SCRIPTS_API extern cst Create_Sound_Team;
+SCRIPTS_API extern c2dst Create_2D_Sound_Team;
+SCRIPTS_API extern c2dwst Create_2D_WAV_Sound_Team;
+SCRIPTS_API extern c2dwstd Create_2D_WAV_Sound_Team_Dialog;
+SCRIPTS_API extern c2dwstc Create_2D_WAV_Sound_Team_Cinematic;
+SCRIPTS_API extern c3dwsbt Create_3D_WAV_Sound_At_Bone_Team;
+SCRIPTS_API extern c3dsbt Create_3D_Sound_At_Bone_Team;
+SCRIPTS_API extern _Stop_Sound_Player Stop_Sound_Player;
+SCRIPTS_API extern _Stop_Sound_Team Stop_Sound_Team;
+SCRIPTS_API extern ssa Set_Subobject_Animation;
+SCRIPTS_API extern sts Set_Time_Scale;
+SCRIPTS_API extern ssap Set_Subobject_Animation_Player;
+SCRIPTS_API extern wfa Write_File_Async;
 
 class SCRIPTS_API JFW_Key_Hook_Base : public ScriptImpClass {
 public:
@@ -474,19 +546,16 @@
 SCRIPTS_API void Kill_All_Buildings_By_Team(int Team); //kill all buildings of the specified team,ending the game with the other team winning,0 = Nod,1 = GDI
 SCRIPTS_API void Set_Occupants_Fade(GameObject *obj,float red,float green,float blue,float opacity); //sets the screen fade of all the occupants of a vehicle
 SCRIPTS_API void Enable_Team_Radar(int Team,bool Enable); //enable radar for a given team
-SCRIPTS_API void Create_Sound_Team(const char *soundname,const Vector3 & position,GameObject *obj,int team); //play a 3D sound for a team
-SCRIPTS_API void Create_2D_Sound_Team(const char *soundname,int team); //play a 2D sound for a team
-SCRIPTS_API void Create_2D_WAV_Sound_Team(const char *soundname,int team); //play a 2D WAV sound for a team
-SCRIPTS_API void Create_2D_WAV_Sound_Team_Dialog(const char *soundname,int team); //play a 2D WAV Dialogue sound for a team
-SCRIPTS_API void Create_2D_WAV_Sound_Team_Cinematic(const char *soundname,int team); //play a 2D WAV Cinematic sound for a team
-SCRIPTS_API void Create_3D_WAV_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team); //play a 3D WAV sound at a bone for a team
-SCRIPTS_API void Create_3D_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team); //play a 3D sound at a bone for a team
 SCRIPTS_API void Send_Message_Team(int team,unsigned int red,unsigned int green,unsigned int blue,const char *msg); //send a message to a team
 SCRIPTS_API void Send_Message_With_Obj_Color(GameObject *obj,const char *Msg); //send a messages in a given objects color
 SCRIPTS_API void Send_Message_With_Team_Color(int Team,const char *Msg); //Send a message in a given teams color
 SCRIPTS_API void Ranged_Gap_Effect(Gap_ListNode* FirstNode); //apply gap effect to all units of a team within a range
 SCRIPTS_API void Ranged_Stealth_On_Team(Gap_ListNode* FirstNode); //Apply stealth to all units in the range of this on the relavent team
 SCRIPTS_API bool Can_Team_Build_Vehicle(int Team); //Can this team build vehicles
+SCRIPTS_API DynamicVectorClass<int> Get_Enlisted_Purchase_Items(int team);//Get all defined IDs of enlisted characters
+SCRIPTS_API DynamicVectorClass<int> Get_Purchase_Items(int team, int defType);//Get all defined IDs in the given purchase list
+SCRIPTS_API bool Is_Infantry_Purchaseable(const char *preset,int team); //is this infantry preset purchaseable? (i.e. it would appear on the sidebar and not be hidden or greyed out. Does not do the cost check but does check unit limits)
+SCRIPTS_API bool Is_Vehicle_Purchaseable(const char *preset,int team); //is this vehicle preset purchaseable? (i.e. it would appear on the sidebar and not be hidden or greyed out. Does not do the cost check but does check unit limits)
 
 SCRIPTS_API void SendShaderParam(const char* parameter, const char* value);
 SCRIPTS_API void SendShaderParam(const char* parameter, int value);
diff -urN sourceold/scripts/engine_vector.h source/scripts/engine_vector.h
--- sourceold/scripts/engine_vector.h	2018-11-17 10:23:57.180600000 +1000
+++ source/scripts/engine_vector.h	2020-09-10 09:08:27.961258800 +1000
@@ -222,6 +222,16 @@
 		}
 		return -1;
 	}
+
+	T* begin()
+	{
+		return Vector;
+	}
+
+	const T* begin() const
+	{
+		return Vector;
+	}
 }; // 0010
 
 template <class T> class DynamicVectorClass : public VectorClass<T> {
@@ -490,12 +500,52 @@
 		}
 		return &((*this)[ActiveCount++]);
 	}
+	void Add_Multiple(const DynamicVectorClass<T>& elements)
+	{
+		Add_Multiple(elements.begin(), elements.Count());
+	}
+	void Add_Multiple(const T* elements, int count)
+	{
+		int newcount = ActiveCount + count;
+		Grow(newcount);
+
+		for (int i = 0; i < count; i++)
+		{
+			Vector[ActiveCount + i] = elements[i];
+		}
+		ActiveCount = newcount;
+	}
 	void Add_Multiple(int number_to_add)
 	{
-		for (int i = 0;i < number_to_add;i++)
+		int newcount = ActiveCount + number_to_add;
+		Grow(newcount);
+		ActiveCount = newcount;
+	}
+	// Grows by 1.5x if growth step is 0, otherwise grows according to step size.
+	// Returns false if the resize fails.
+	bool Grow()
+	{
+		if (GrowthStep == 0)
+		{
+			int len = VectorClass<T>::Length();
+			int newlen = len + (len >> 1); // 1.5x
+			if (newlen < 10) newlen = 10; // minimum length 10
+			return Grow(newlen);
+		}
+		else if (GrowthStep > 0)
 		{
-			Uninitialized_Add();
+			return Grow(VectorClass<T>::Length() + GrowthStep);
 		}
+		TT_UNREACHABLE; // somebody set the growth step to negative
+	}
+	// Returns false if the resize fails or we don't need to grow (current length is greater than newlen).
+	bool Grow(int newlen)
+	{
+		if (newlen > Length() && (VectorClass<T>::IsAllocated || !VectorClass<T>::VectorMax))
+		{
+			return Resize(newlen);
+		}
+		return false;
 	}
 }; // 0018
 
@@ -807,12 +857,23 @@
 	{
 		int index = ActiveCount;
 		ActiveCount += number_to_add;
-		if (ActiveCount >= VectorMax)
+		if (ActiveCount > VectorMax)
 		{
-			Grow( ActiveCount );
+			Grow(ActiveCount);
 		}
 		return &Vector[index];
 	}
+	void Add_Multiple(const SimpleDynVecClass<T>& elements)
+	{
+		Add_Multiple(elements.begin(), elements.Count());
+	}
+	void Add_Multiple(const T* elements, int count)
+	{
+		int newcount = ActiveCount + count;
+		if (newcount > VectorMax) Grow(newcount);
+		memcpy(Vector + ActiveCount, elements, count * sizeof(T));
+		ActiveCount = newcount;
+	}
 	bool Add_Head(const T& object)
 	{
 		return Insert(0, object);
diff -urN sourceold/scripts/gmgame.cpp source/scripts/gmgame.cpp
--- sourceold/scripts/gmgame.cpp	2019-06-22 07:43:44.230400000 +1000
+++ source/scripts/gmgame.cpp	2020-03-28 21:10:59.027822400 +1000
@@ -201,7 +201,9 @@
 	Vector3	damagerpos = Commands->Get_Position(killer);
 	const char *str1 = Get_Translated_Preset_Name_Ex(obj);
 	const char *str2 = Get_Translated_Preset_Name_Ex(killer);
-	SSGMGameLog::Log_Gamelog("KILLED;%s;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s;%s;%s", objectType, Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer), killerPreset, int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)), killerWeapon, str1, str2, Get_Player_Name(killer), Get_Player_Name(killedObj));
+	SSGMGameLog::Log_Gamelog("KILLED;%s;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s;%ls;%ls", objectType, Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer), killerPreset, int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)), killerWeapon, str1, str2, Get_Wide_Player_Name(killer), Get_Wide_Player_Name(killedObj));
+	delete[] str1;
+	delete[] str2;
 }
 
 SCRIPTS_API void RegisterEvent(EventType evt,Plugin *plugin)
diff -urN sourceold/scripts/gmplugin.h source/scripts/gmplugin.h
--- sourceold/scripts/gmplugin.h	2018-11-17 10:23:57.190600000 +1000
+++ source/scripts/gmplugin.h	2020-04-02 12:02:44.438361500 +1000
@@ -13,7 +13,7 @@
 #define TT_INCLUDE_GMPLUGIN_H
 #include "scripts.h"
 #include "engine.h"
-#define INTERFACE_VERSION 4.6f
+#define INTERFACE_VERSION 4.7f
 
 enum EventType {
 	EVENT_GLOBAL_INI = 0,
